import os
import sqlite3

import xbmc

from resources.lib.const import DB_TABLE
from resources.lib.kodilogging import service_logger
from resources.lib.utils.kodiutils import data_dir


class SQLiteStorage:
    def __init__(self):
        db_path = xbmc.translatePath(data_dir())
        self.db_path = os.path.join(db_path, "data.db")

    def execute(self, query):
        service_logger.debug('DB: Executed ' + query)
        with sqlite3.connect(self.db_path) as conn:
            c = conn.cursor()
            c.execute(query)
            conn.commit()

    def select(self, query):
        with sqlite3.connect(self.db_path) as conn:
            c = conn.cursor()
            c.execute(query)
            return c

    class WatchHistory:
        TABLE_NAME = DB_TABLE.WATCH_HISTORY

        def __init__(self):
            self.db = SQLiteStorage()
            self.db.execute(
                '''CREATE TABLE IF NOT EXISTS ''' + self.TABLE_NAME +
                ''' (media_id text PRIMARY KEY, watched text)''')

        def add(self, media_id):
            self.db.execute("INSERT or REPLACE INTO " + self.TABLE_NAME + " VALUES ('" + media_id + "',datetime('now', 'localtime'))")

        def get_all(self):
            cur = self.db.select("SELECT * FROM " + self.TABLE_NAME + " ORDER BY datetime(watched) DESC")
            return cur.fetchall()
